import getBasePlacement from "../utils/getBasePlacement";
import { basePlacements, top, bottom, left, right } from "../enums";
export function distanceAndSkiddingToXY(placement, measures, getOffsets) {
    const basePlacement = getBasePlacement(placement);
    // @ts-ignore
    const invertDistance = [left, top].includes(basePlacement) ? -1 : 1;
    let [distance, skidding] = getOffsets(Object.assign(Object.assign({}, measures), { placement }));
    distance = (distance || 0) * invertDistance;
    skidding = skidding || 0;
    // @ts-ignore
    return [left, right].includes(basePlacement) ? [distance, skidding] : [skidding, distance];
}
export function offset({ state, options }) {
    if (typeof options.offset === 'function') {
        const [x, y] = distanceAndSkiddingToXY(state.placement, state.measures, options.offset);
        // Add the offset to `detectOverflow`
        basePlacements.forEach(placement => {
            // @ts-ignore
            const isVertical = [top, bottom].includes(placement);
            const value = isVertical ? y : x;
            ['clippingArea', 'visibleArea'].forEach(property => {
                state.modifiersData.detectOverflow[property][placement] += value;
            });
        });
        state.modifiersData.popperOffsets.x += x;
        state.modifiersData.popperOffsets.y += y;
    }
    return state;
}
export default {
    name: 'offset',
    enabled: true,
    phase: 'main',
    requires: ['popperOffsets', 'detectOverflow'],
    fn: offset
};
